/*
 * Copyright (C) 1997  Warren Jasper
 * All rights reserved.
 *
 */


/***************************************************************************
 *
 *  test-ctr05.c
 *
 *  This program is used to test the CIO-CTR05 Counter Board
 *  Linux loadable module.
 *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include "ctr05.h"
#include "c9513.h"

/***************************************************************************
 *
 *  Global Data
 *
 ***************************************************************************/

char *DevName = "/dev/ctr05_CTR1";
int  Mode     = CTR05_COUNTER;
int  Print    = 1;
int  Status;

int fdDIO;
int fdctr_1;
int fdctr_2;
int fdctr_3;
int fdctr_4;
int fdctr_5;

void DoOpenDevices()
{
  char str[80];

  strcpy(str,"/dev/ctr05_DIO");
  if ((fdDIO=open(str, Mode))<0) 
    {
     perror(str);
     printf("error opening device %s\n",str);
     exit(2);
    }

  strcpy(str,"/dev/ctr05_CTR1");
  if ((fdctr_1=open(str, Mode))<0) 
    {
     perror(str);
     printf("error opening device %s\n",str);
     exit(2);
    }

  strcpy(str,"/dev/ctr05_CTR2");
  if ((fdctr_2=open(str, Mode))<0) 
    {
     perror(str);
     printf("error opening device %s\n",str);
     exit(2);
    }

  strcpy(str,"/dev/ctr05_CTR3");
  if ((fdctr_3=open(str, CTR05_FREQUENCY))<0) 
    {
     perror(str);
     printf("error opening device %s\n",str);
     exit(2);
    }

  strcpy(str,"/dev/ctr05_CTR4");
  if ((fdctr_4=open(str, CTR05_FREQUENCY))<0) 
    {
     perror(str);
     printf("error opening device %s\n",str);
     exit(2);
    }

  strcpy(str,"/dev/ctr05_CTR5");
  if ((fdctr_5=open(str, CTR05_FREQUENCY))<0) 
    {
     perror(str);
     printf("error opening device %s\n",str);
     exit(2);
    }
  
} 

void testCounter()
{
  WORD value;
  char str[80];
  int source,counter;
 
  while (1) {
    printf("Input counter no. [1 or 2]: ");
    scanf("%d",&counter);
    if (counter <1 || counter > 2) {
      printf("Illegal counter no. Counter no. should be 1 or 2.\n\n");
      continue;
    }
    printf("Input source no.:");
    scanf("%d",&source);
    if (source <0 || source > 15) {
      printf("Illegal source no. Source no. should be 0-15.\n\n");
      continue;
    }
    source <<= 8;
    write(fdctr_1+counter-1,&source,2);
    sleep(1);
    read(fdctr_1+counter-1,&value,1);
    printf("%d events in a second\n",value);
    printf("\nContinue? ");
    scanf("%s",str);
    if (str[0]=='N' || str[0]=='n') return;

  }
}

/*void testCounter()
{

  WORD value;

  ioctl(fdctr_1,LOAD_COUNTER_MODE_REG,COUNTUP | 0x200);
  ioctl(fdctr_1,LOAD_CMD_REG,LOAD_REG |0x1);
  ioctl(fdctr_1,LOAD_DATA_REG, 0);
  ioctl(fdctr_1,LOAD_CMD_REG,LOAD_ARM |0x1);
  sleep(1);
  read(fdctr_1,&value,1);
  printf("value %d!!!!!\n",value);
}*/

void testFreq()
{
  WORD value;
  char str[80];
  int source,counter;

  while (1) {
    printf("Input source no.: ");
    scanf("%d",&source);
    if (source <0 || source > 15) {
      printf("Illegal source no. Source no. should be 0-15.\n\n");
      continue;
    }
    source <<= 8;
    printf("Input counter no. [3 or 4]: ");
    scanf("%d",&counter);
    if (counter != 3 && counter !=4)
      printf("Illegal counter no. Counter no. should be 3 or 4.\n\n");
    else 
      break;
  }

  ioctl(fdctr_1+counter-1, SET_GATE_INTERVAL, 1000);  /* 1000 = 1 second */
  write(fdctr_1+counter-1,&source,2);
  sleep(1);

  while (1) {
    sleep(1);
    read(fdctr_1+counter-1,&value,1);
    printf("Frequency is %d\n",value);
    printf("\nContinue? ");
    scanf("%s",str);
    if (str[0]=='N' || str[0]=='n') {
      ioctl(fdctr_5, LOAD_CMD_REG, DISARM | (1<<(counter-1)) | CTR5_BIT);
      return;
    }
  }
}

void testDIO()
{
  unsigned int value, bReg;
  char str[80];

  while (1) {
    printf("Enter value for output in hex:");
    scanf("%x", &value);
    write(fdDIO, &value,1);
    read(fdDIO, &bReg,1);
    printf("Input value =%x\n",bReg);
    printf("\n Continue? ");
    scanf("%s",str);
    if (str[0] == 'n' || str[0] == 'N') return;
  }

}

void Domenu()
{
  int choice;

  while (1) {
    //system("/usr/bin/clear");
    printf("Select from the following choices:\n");
    printf("\t1. Test Counter.\n");
    printf("\t2. Measure Frequency.\n");
    printf("\t3. Test Digital I/O.\n");
    printf("\t4. Exit.\n");
    printf("\nOption: ");

    scanf("%d", &choice);
    switch (choice) {
    case 1: 
      testCounter();
      break;
    case 2:
      testFreq();
      break;
    case 3:
      testDIO();
      break;
    case 4:
      return;
      break;
    default:
      break;
    }
  }
}

int main(int argc, char **argv)
{
  DoOpenDevices();
  Domenu();
  close(fdDIO);
  close(fdctr_1);
  close(fdctr_2);
  close(fdctr_3);
  close(fdctr_4);
  close(fdctr_5);
  return(0);
}
























































































































































































































































































































































































































































































